import { _Column, IValue, _Transaction, SchemaField, nil, ISubscription, DropHandler } from './interfaces-private';
import type { MemoryTable } from './table';
import { Evaluator } from './evaluator';
import { ColumnConstraint, AlterColumn } from 'pgsql-ast-parser';
import { BIndex } from './schema/btree-index';
export declare class ColRef implements _Column {
    readonly table: MemoryTable;
    expression: Evaluator;
    name: string;
    default: IValue | nil;
    notNull: boolean;
    usedInIndexes: Set<BIndex<any>>;
    private drophandlers;
    constructor(table: MemoryTable, expression: Evaluator, _schema: SchemaField, name: string);
    addConstraints(clist: ColumnConstraint[], t: _Transaction): this;
    private addNotNullConstraint;
    rename(to: string, t: _Transaction): this;
    alter(alter: AlterColumn, t: _Transaction): this;
    private replaceExpression;
    drop(t: _Transaction): void;
    checkConstraints(toInsert: any, t: _Transaction): void;
    setDefaults(toInsert: any, t: _Transaction): void;
    onDrop(sub: DropHandler): ISubscription;
}
//# sourceMappingURL=column.d.ts.map