import { AlterSequenceChange, CreateSequenceOptions } from 'pgsql-ast-parser';
import { _ISchema, _ISequence, _IType, _Transaction, Reg } from '../interfaces-private';
import { nil } from '../interfaces';
export declare class Sequence implements _ISequence {
    name: string;
    readonly ownerSchema: _ISchema;
    get type(): 'sequence';
    private symbol;
    private owner?;
    private cfg;
    readonly reg: Reg;
    get cycle(): boolean;
    get dataType(): _IType<any>;
    get inc(): number;
    constructor(name: string, ownerSchema: _ISchema);
    get start(): number;
    get max(): number;
    get min(): number;
    alter(t: _Transaction, opts: CreateSequenceOptions | AlterSequenceChange | nil): this;
    nextValue(t: _Transaction): number;
    setValue(t: _Transaction, value: number): void;
    restart(t: _Transaction): void;
    currentValue(t: _Transaction): number;
    private alterOpts;
    drop(t: _Transaction): void;
}
//# sourceMappingURL=sequence.d.ts.map